package org.jeecg.modules.okki.showlist.service.impl;

import org.jeecg.modules.okki.showlist.entity.OkkiShowlist;
import org.jeecg.modules.okki.showlist.entity.OkkiOverview;
import org.jeecg.modules.okki.showlist.entity.OkkiProductList;
import org.jeecg.modules.okki.showlist.entity.OkkiHighlight;
import org.jeecg.modules.okki.showlist.entity.OkkiAdvantage;
import org.jeecg.modules.okki.showlist.entity.OkkiRecommendedProducts;
import org.jeecg.modules.okki.showlist.entity.OkkiKeywords;
import org.jeecg.modules.okki.showlist.entity.OkkiKeywordsSeries;
import org.jeecg.modules.okki.showlist.entity.OkkiReview;
import org.jeecg.modules.okki.showlist.entity.OkkiFaq;
import org.jeecg.modules.okki.showlist.entity.OkkiShowlistBlog;
import org.jeecg.modules.okki.showlist.mapper.OkkiOverviewMapper;
import org.jeecg.modules.okki.showlist.mapper.OkkiProductListMapper;
import org.jeecg.modules.okki.showlist.mapper.OkkiHighlightMapper;
import org.jeecg.modules.okki.showlist.mapper.OkkiAdvantageMapper;
import org.jeecg.modules.okki.showlist.mapper.OkkiRecommendedProductsMapper;
import org.jeecg.modules.okki.showlist.mapper.OkkiKeywordsMapper;
import org.jeecg.modules.okki.showlist.mapper.OkkiKeywordsSeriesMapper;
import org.jeecg.modules.okki.showlist.mapper.OkkiReviewMapper;
import org.jeecg.modules.okki.showlist.mapper.OkkiFaqMapper;
import org.jeecg.modules.okki.showlist.mapper.OkkiShowlistBlogMapper;
import org.jeecg.modules.okki.showlist.mapper.OkkiShowlistMapper;
import org.jeecg.modules.okki.showlist.service.IOkkiShowlistService;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import java.io.Serializable;
import java.util.List;
import java.util.Collection;

/**
 * @Description: showlist
 * @Author: jeecg-boot
 * @Date:   2024-05-14
 * @Version: V1.0
 */
@Service
public class OkkiShowlistServiceImpl extends ServiceImpl<OkkiShowlistMapper, OkkiShowlist> implements IOkkiShowlistService {

	@Autowired
	private OkkiShowlistMapper okkiShowlistMapper;
	@Autowired
	private OkkiOverviewMapper okkiOverviewMapper;
	@Autowired
	private OkkiProductListMapper okkiProductListMapper;
	@Autowired
	private OkkiHighlightMapper okkiHighlightMapper;
	@Autowired
	private OkkiAdvantageMapper okkiAdvantageMapper;
	@Autowired
	private OkkiRecommendedProductsMapper okkiRecommendedProductsMapper;
	@Autowired
	private OkkiKeywordsMapper okkiKeywordsMapper;
	@Autowired
	private OkkiKeywordsSeriesMapper okkiKeywordsSeriesMapper;
	@Autowired
	private OkkiReviewMapper okkiReviewMapper;
	@Autowired
	private OkkiFaqMapper okkiFaqMapper;
	@Autowired
	private OkkiShowlistBlogMapper okkiShowlistBlogMapper;
	
	@Override
	@Transactional(rollbackFor = Exception.class)
	public void saveMain(OkkiShowlist okkiShowlist, List<OkkiOverview> okkiOverviewList,List<OkkiProductList> okkiProductListList,List<OkkiHighlight> okkiHighlightList,List<OkkiAdvantage> okkiAdvantageList,List<OkkiRecommendedProducts> okkiRecommendedProductsList,List<OkkiKeywords> okkiKeywordsList,List<OkkiKeywordsSeries> okkiKeywordsSeriesList,List<OkkiReview> okkiReviewList,List<OkkiFaq> okkiFaqList,List<OkkiShowlistBlog> okkiShowlistBlogList) {
		okkiShowlistMapper.insert(okkiShowlist);
		if(okkiOverviewList!=null && okkiOverviewList.size()>0) {
			for(OkkiOverview entity:okkiOverviewList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiOverviewMapper.insert(entity);
			}
		}
		if(okkiProductListList!=null && okkiProductListList.size()>0) {
			for(OkkiProductList entity:okkiProductListList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiProductListMapper.insert(entity);
			}
		}
		if(okkiHighlightList!=null && okkiHighlightList.size()>0) {
			for(OkkiHighlight entity:okkiHighlightList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiHighlightMapper.insert(entity);
			}
		}
		if(okkiAdvantageList!=null && okkiAdvantageList.size()>0) {
			for(OkkiAdvantage entity:okkiAdvantageList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiAdvantageMapper.insert(entity);
			}
		}
		if(okkiRecommendedProductsList!=null && okkiRecommendedProductsList.size()>0) {
			for(OkkiRecommendedProducts entity:okkiRecommendedProductsList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiRecommendedProductsMapper.insert(entity);
			}
		}
		if(okkiKeywordsList!=null && okkiKeywordsList.size()>0) {
			for(OkkiKeywords entity:okkiKeywordsList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiKeywordsMapper.insert(entity);
			}
		}
		if(okkiKeywordsSeriesList!=null && okkiKeywordsSeriesList.size()>0) {
			for(OkkiKeywordsSeries entity:okkiKeywordsSeriesList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiKeywordsSeriesMapper.insert(entity);
			}
		}
		if(okkiReviewList!=null && okkiReviewList.size()>0) {
			for(OkkiReview entity:okkiReviewList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiReviewMapper.insert(entity);
			}
		}
		if(okkiFaqList!=null && okkiFaqList.size()>0) {
			for(OkkiFaq entity:okkiFaqList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiFaqMapper.insert(entity);
			}
		}
		if(okkiShowlistBlogList!=null && okkiShowlistBlogList.size()>0) {
			for(OkkiShowlistBlog entity:okkiShowlistBlogList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiShowlistBlogMapper.insert(entity);
			}
		}
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public void updateMain(OkkiShowlist okkiShowlist,List<OkkiOverview> okkiOverviewList,List<OkkiProductList> okkiProductListList,List<OkkiHighlight> okkiHighlightList,List<OkkiAdvantage> okkiAdvantageList,List<OkkiRecommendedProducts> okkiRecommendedProductsList,List<OkkiKeywords> okkiKeywordsList,List<OkkiKeywordsSeries> okkiKeywordsSeriesList,List<OkkiReview> okkiReviewList,List<OkkiFaq> okkiFaqList,List<OkkiShowlistBlog> okkiShowlistBlogList) {
		okkiShowlistMapper.updateById(okkiShowlist);
		
		//1.先删除子表数据
		okkiOverviewMapper.deleteByMainId(okkiShowlist.getId());
		okkiProductListMapper.deleteByMainId(okkiShowlist.getId());
		okkiHighlightMapper.deleteByMainId(okkiShowlist.getId());
		okkiAdvantageMapper.deleteByMainId(okkiShowlist.getId());
		okkiRecommendedProductsMapper.deleteByMainId(okkiShowlist.getId());
		okkiKeywordsMapper.deleteByMainId(okkiShowlist.getId());
		okkiKeywordsSeriesMapper.deleteByMainId(okkiShowlist.getId());
		okkiReviewMapper.deleteByMainId(okkiShowlist.getId());
		okkiFaqMapper.deleteByMainId(okkiShowlist.getId());
		okkiShowlistBlogMapper.deleteByMainId(okkiShowlist.getId());
		
		//2.子表数据重新插入
		if(okkiOverviewList!=null && okkiOverviewList.size()>0) {
			for(OkkiOverview entity:okkiOverviewList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiOverviewMapper.insert(entity);
			}
		}
		if(okkiProductListList!=null && okkiProductListList.size()>0) {
			for(OkkiProductList entity:okkiProductListList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiProductListMapper.insert(entity);
			}
		}
		if(okkiHighlightList!=null && okkiHighlightList.size()>0) {
			for(OkkiHighlight entity:okkiHighlightList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiHighlightMapper.insert(entity);
			}
		}
		if(okkiAdvantageList!=null && okkiAdvantageList.size()>0) {
			for(OkkiAdvantage entity:okkiAdvantageList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiAdvantageMapper.insert(entity);
			}
		}
		if(okkiRecommendedProductsList!=null && okkiRecommendedProductsList.size()>0) {
			for(OkkiRecommendedProducts entity:okkiRecommendedProductsList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiRecommendedProductsMapper.insert(entity);
			}
		}
		if(okkiKeywordsList!=null && okkiKeywordsList.size()>0) {
			for(OkkiKeywords entity:okkiKeywordsList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiKeywordsMapper.insert(entity);
			}
		}
		if(okkiKeywordsSeriesList!=null && okkiKeywordsSeriesList.size()>0) {
			for(OkkiKeywordsSeries entity:okkiKeywordsSeriesList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiKeywordsSeriesMapper.insert(entity);
			}
		}
		if(okkiReviewList!=null && okkiReviewList.size()>0) {
			for(OkkiReview entity:okkiReviewList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiReviewMapper.insert(entity);
			}
		}
		if(okkiFaqList!=null && okkiFaqList.size()>0) {
			for(OkkiFaq entity:okkiFaqList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiFaqMapper.insert(entity);
			}
		}
		if(okkiShowlistBlogList!=null && okkiShowlistBlogList.size()>0) {
			for(OkkiShowlistBlog entity:okkiShowlistBlogList) {
				//外键设置
				entity.setOkkiShowlistId(okkiShowlist.getId());
				okkiShowlistBlogMapper.insert(entity);
			}
		}
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public void delMain(String id) {
		okkiOverviewMapper.deleteByMainId(id);
		okkiProductListMapper.deleteByMainId(id);
		okkiHighlightMapper.deleteByMainId(id);
		okkiAdvantageMapper.deleteByMainId(id);
		okkiRecommendedProductsMapper.deleteByMainId(id);
		okkiKeywordsMapper.deleteByMainId(id);
		okkiKeywordsSeriesMapper.deleteByMainId(id);
		okkiReviewMapper.deleteByMainId(id);
		okkiFaqMapper.deleteByMainId(id);
		okkiShowlistBlogMapper.deleteByMainId(id);
		okkiShowlistMapper.deleteById(id);
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public void delBatchMain(Collection<? extends Serializable> idList) {
		for(Serializable id:idList) {
			okkiOverviewMapper.deleteByMainId(id.toString());
			okkiProductListMapper.deleteByMainId(id.toString());
			okkiHighlightMapper.deleteByMainId(id.toString());
			okkiAdvantageMapper.deleteByMainId(id.toString());
			okkiRecommendedProductsMapper.deleteByMainId(id.toString());
			okkiKeywordsMapper.deleteByMainId(id.toString());
			okkiKeywordsSeriesMapper.deleteByMainId(id.toString());
			okkiReviewMapper.deleteByMainId(id.toString());
			okkiFaqMapper.deleteByMainId(id.toString());
			okkiShowlistBlogMapper.deleteByMainId(id.toString());
			okkiShowlistMapper.deleteById(id);
		}
	}

	@Override
	public boolean changeStatus(OkkiShowlist okkiShowlist) {
		return false;
	}

}
